#include <windows.h>
#include <lm.h>
#include <stdio.h>

#pragma comment(lib, "netapi32.lib")

void PrintError(LPSTR lpszApi, DWORD res);

int wmain()
{
   PUSER_INFO_10 p;
   DWORD res, dwSize;

   // Call the NetApiBufferAllocate function 
   //   to allocate the memory. If successful,
   //   print a message.
   res = NetApiBufferAllocate(1024, (LPVOID *) &p);
   if(res == NERR_Success)
   {
      wprintf(L"NetApiBufferAllocate():   Allocated 1024 bytes.\n");

      // Call the NetApiBufferSize function 
      //   to retrieve the size of the allocated buffer.
      //   If successful, print the size.
      res = NetApiBufferSize(p, &dwSize);
      if(res == NERR_Success)
      {
         wprintf(L"NetApiBufferSize():       Buffer has %u bytes.\n", dwSize);

         // Call the NetApiBufferReallocate function
         //   to change the size of the allocated memory.
         //   If successful, print the new size of the buffer.
         res = NetApiBufferReallocate(p, dwSize * 2, (LPVOID *) &p);

         if(res == NERR_Success)
            wprintf(L"NetApiBufferReallocate(): Re-Allocated %u bytes.\n", dwSize * 2);
         else
            PrintError("NetApiBufferReallocate()", res);

         // Call the NetApiBufferFree function
         //    to free the allocated memory.
         //    If successful, print a message.
         res = NetApiBufferFree(p);

         if(res == NERR_Success)
			 wprintf(L"NetApiBufferFree():       Freed Buffer\n");

         else
            PrintError("NetApiBufferFree()", res);
      }
      else
         PrintError("NetApiBufferSize()", res);
   }         
   else
      PrintError("NetApiBufferAllocate()", res);
   return 0;
}

void PrintError(LPSTR lpszApi, DWORD res)
{
   wprintf(L"%s: Error %u\n", lpszApi, res);
   return;
}
